<?php

add_action('admin_footer','rpur_feed_js');

add_action('admin_footer','rpur_feed_js');

function rpur_print_feeds($feeds=''){
	?>

<thead><tr><td></td><td>Feed Name</td><td>Feed URL</td><td>Category</td><td>Tags(Separated by comma)</td><td>Author</td><td>Update Every(Minutes)</td><td>Get Articles</td><td>Rewrite</td><td>Post Status</td><td>Post Interval(Hours)</td></tr></thead>
		<tr id="feed_first">

		<td><input type='hidden' value='' name='rpur_feed[0][id]'></td>
		<td><input type='text' style='width:90%;' size='25' value='' name='rpur_feed[0][name]' /></td>
		<td><input type='text' style='width:90%;' size='100' value='' name='rpur_feed[0][url]' /></td>
		<td><select name='rpur_feed[0][category]'><?php echo rpur_print_categories();?></select></td>
		<td><input type='text' style='width:90%;' value='' name='rpur_feed[0][tags]'></input></td>
		<td><select name='rpur_feed[0][author]'><?php echo rpur_print_authors();?></select></td>
		<td><input type='text' value='1440' style='width:90%;' value='' name='rpur_feed[0][frequency]'></input></td>
		<td><input type='text' size='2' value = '3' name='rpur_feed[0][max_items]'></td>
		<td><select name='rpur_feed[0][rewrite]'><?php echo rpur_print_rewrite();?></select></td>
		<td><select name='rpur_feed[0][post_status]'><?php echo rpur_print_post_status();?></select></td>
		<td><input type='text' size='2' value = '0' name='rpur_feed[0][post_interval]'></td>
		
		</tr>

<?php

		
		$x++;
		if($feeds){
			
			while (list($name, $ops) = each($feeds)) {

				echo "
				<tr>
				<td><input type='hidden'value='{$ops['id']}' name='rpur_feed[$x][id]'></td>
				<td><input type='text' style='width:90%;' size='25' value='{$ops['name']}' name='rpur_feed[$x][name]' /></td>
				<td><input type='text' style='width:90%;' size='100' value='{$ops['url']}' name='rpur_feed[$x][url]' /></td>
				<td><select name='rpur_feed[$x][category]'>". rpur_print_categories($ops['category'])."</select></td>
				<td><input type='text' style='width:90%;' value='{$ops['tags']}' name='rpur_feed[$x][tags]'></input></td>
				<td><select name='rpur_feed[$x][author]'>".rpur_print_authors($ops['author'])."</select></td>
				<td><input type='text' style='width:90%;' value='{$ops['frequency']}' name='rpur_feed[$x][frequency]'></input></td>
				<td><input type='text' size='2' value = '{$ops['max_items']}' name='rpur_feed[$x][max_items]'></td>
				<td><select name='rpur_feed[$x][rewrite]'>".rpur_print_rewrite($ops['rewrite'])."</select></td>
				<td><select name='rpur_feed[$x][post_status]'>".rpur_print_post_status($ops['post_status'])."</select></td>
				<td><input type='text' size='2' value = '{$ops['post_interval']}' name='rpur_feed[$x][post_interval]'></td>
				<td><input onclick='rpur_feed_js({$ops['id']})' class='button' type='button' value='Fetch Now'></input></td>

				</tr>
	
				";

				$x++;

		}

		}
		
}

function rpur_feed_page(){
	
	$rpur_options=get_option('rpur_options');
	
	if (isset($_POST['rpur_save'])) {
		
		$feeds=$_POST['rpur_feed'];
		
		foreach($feeds as $feed){

			if(!empty($feed['id'])){

				if( empty($feed['name'])||empty($feed['url'])  )
					rpur_delete_feed($feed);
				else
					rpur_update_feed($feed);

			}elseif( empty($feed['name']) || empty($feed['url']) )
				continue;
			else
				rpur_insert_feed($feed);
	
		}

		echo	'<div id="message" class="updated fade"><p>Saved!</p></div>';

	}elseif (isset($_POST['rpur_reset'])) {

		rpur_reinstall();
		echo	'<div id="message" class="updated fade"><p>You are done reinstalling RSS Poster!</p></div>';



	}elseif($_GET['action'] == 'done'){

		echo	'<div id="message" class="updated fade"><p>Fetch Done! See <a href="admin.php?page=rpur_log_page&s=logs&p=last">log</a> for details.</p></div>';
	}
	


?>

<script type="text/javascript">
			var increment = 10000;

			function more_feeds(){
		
				jQuery("#feed_first").before("<tr><td><input type='hidden' value='' name='rpur_feed["+increment+"][id]'></td><td><input type='text' style='width:90%;' size='25' value='' name='rpur_feed["+increment+"][name]' /></td><td><input type='text' style='width:90%;' size='100' value='' name='rpur_feed["+increment+"][url]' /></td><td><select name='rpur_feed["+increment+"][category]'><?php echo rpur_print_categories();?></select></td><td><input type='text' style='width:90%;' value='' name='rpur_feed["+increment+"][tags]'></input></td><td><select name='rpur_feed["+increment+"][author]'><?php echo rpur_print_authors();?></select></td><td><input type='text' style='width:90%;' value='1440' name='rpur_feed["+increment+"][frequency]'></input></td><td><input type='text' size='2' value = '3' name='rpur_feed["+increment+"][max_items]'></td><td><select name='rpur_feed["+increment+"][rewrite]'><?php echo rpur_print_rewrite();?></select></td><td><select name='rpur_feed["+increment+"][post_status]'><?php echo rpur_print_post_status();?></select></td><td><input type='text' size='2' value = '3' name='rpur_feed["+increment+"][post_interval]'></td></td></tr>");

						increment++;

}

</script>
	<div class="wrapper">

<form method="post">
<h2>RSS Poster PRO Version</h2>	
<h4>RSS Poster PRO Version will automatically grab FULL articles from Unlimited RSS Feeds and REWRITE them.</h4>
<h2>Instruction</h2>
<p style='font-size:13px;'>To add a feed, simply fill the Feed Name and Feed URL boxes with related data.Then select the other options as preferred.</p>
<p style='font-size:13px;'>To replace a feed, write over the previous options.</p>
<p style='font-size:13px;'>To delete a feed, simply leave Feed Name or Feed URL box blank.</p>
<p style='font-size:13px;'>With post interval, posts will be scheduled. 1st article will be current time, 2nd article will be current time + post interval</p>
<p style='font-size:13px;'>When finished hit the UPDATE SETTINGS button below, that's it!</p>
<p style='font-size:13px;'><b>Please note</b>, if rewrite is NOT selected, the RSS feed source will be shown as article footer. If rewrite option is selected, RSS feed source will be attributed to admin. If the associated feed is deleted, the post will be rewritten by default.</p>
<p style='font-size:13px;'>Please read the <a href="http://www.wprssposter.com/faq.html">FAQ</a> of RSS Poster.</p>
<p style='font-size:13px;'>Please <a href="http://www.wprssposter.com/blog/wp-login.php">login</a> to leave your feedback or feature request at <a href="http://www.wprssposter.com/blog/?p=42">here</a>.</p>
<h4>Popular NEWS Feeds</h4>
<p style='font-size:11px;'>http://news.google.com/news?q=your keyword&output=rss</p>
<p style='font-size:11px;'>http://news.search.yahoo.com/news/rss?p=your keyword</p>
<p style='font-size:11px;'>http://api.bing.com/rss.aspx?Source=News&Market=en-US&Version=2.0&Query=your keyword</p>
<img src="<?php echo RPUR_URL_ROOT;?>images/ajax-loader.gif" id="wait" style="display:none;"/>

<table width="70%" id="rpur_feed">
<?php rpur_print_feeds(rpur_get_feeds());?>
</table>
<p><a href="#" onclick="more_feeds(); return false;">Add More Feeds</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input onclick='rpur_fetch_all();' size=13 class="button" value="Fetch ALL Feeds"></p>

<p><input type="submit" class="button-primary" value="UPDATE SETTINGS" name="rpur_save"></p>
<p><input type="submit" onclick="return confirm('Export your data before reinstalling!')" class="button" value="Reinstall RSS Poster" name="rpur_reset"></p>
<p></p>
</form>
Thanks for purchasing RSS Poster PRO Version, don't forget to register at http://www.wprssposter.com/blog/wp-login.php?action=register with the code xxxx-xxxx-xxxx in order for future update and exclusive technical support.<br>
If you can't find the code, please check your inbox. Or contact me with payment details. wprssposter@gmail.com <br />

</div>
<?php
}
function rpur_print_categories($id=''){
	
	$categories=  get_categories('hide_empty=0');
	$results='';
	foreach ($categories as $cat) {

		$option = "<option value='". $cat->cat_ID . "'";

		if($id == $cat->cat_ID )
$option .= " selected='selected' ";

		$option .= '>';




		$option .= $cat->cat_name;

		$option .= '</option>';


		$results.=$option;
	}
            
	return $results;
}

function rpur_print_post_status($opt=''){
	
	$status=array('publish','draft');
	foreach ($status as $s) {

		$option = "<option value='". $s . "'";

		if($opt == $s )
$option .= " selected='selected' ";

		$option .= '>';

		$option .= $s;

		$option .= '</option>';

		$results.=$option;
	}
            
	return $results;
}
function rpur_print_authors($opt=''){

	global $wpdb;
	$users = $wpdb->get_results("SELECT user_id,meta_value FROM $wpdb->usermeta WHERE (meta_key = 'nickname')",ARRAY_A);
	
	foreach($users as $user){

		$option = "<option value='". $user['user_id'] . "'";

		if($opt == $user['user_id'] )
			$option .= " selected='selected' ";

		$option .= '>';

		$option .= $user['meta_value'];

		$option .= '</option>';

		$results.=$option;

	}
	return $results;



}
function rpur_print_rewrite($opt=''){
	
	$status=array('Yes','No');
	foreach ($status as $s) {

		$option = "<option value='". $s . "'";

		if($opt == $s )
			$option .= " selected='selected' ";

		$option .= '>';

		$option .= $s;

		$option .= '</option>';

		$results.=$option;
	}
            
	return $results;
}



function rpur_feed_js(){
?>

<script type='text/javascript'>
function rpur_fetch_all(){
	
	
	showDiv("#wait");
	
	jQuery('body').fadeTo('slow',0.5);



	jQuery.ajax({
	type : 'POST',
	url : "<?php echo RPUR_PROCESS_FEED_FILE; ?>",
	data: {
		fetch_all: true
		
	},
	timeout: 600000,
	async: true,
	dataType: "html",
	success : function(data){
		jQuery('#wait').hide();
		window.location.replace("admin.php?page=rpur_feed_page&action=done");
		
	},
	error: function (xhr, status, error) {
        	alert("Error! "+xhr.statusText );
    	}
	});
	



}
function rpur_feed_js(feed_id){
	feed_id="0"+feed_id;

	showDiv("#wait");
	
	jQuery('body').fadeTo('slow',0.5);



	jQuery.ajax({
	type : 'POST',
	url : "<?php echo RPUR_PROCESS_FEED_FILE; ?>",
	data: {
		feed_id : feed_id
		
	},
	timeout: 600000,
	async: true,
	dataType: "html",
	success : function(data){
		jQuery('#wait').hide();
		window.location.replace("admin.php?page=rpur_feed_page&action=done");
		
	},
	error: function (xhr, status, error) {
        	alert("Error! "+xhr.statusText );
    	}
	});
	



}

function showDiv(obj){
 jQuery(obj).show();
 center(obj);
 jQuery(window).scroll(function(){
  center(obj);
 });
 jQuery(window).resize(function(){
  center(obj);
 }); 
}
function center(obj){
 var windowWidth = document.documentElement.clientWidth;   
 var windowHeight = document.documentElement.clientHeight;   
 var popupHeight = jQuery(obj).height();   
 var popupWidth = jQuery(obj).width();    
 jQuery(obj).css({   
  "position": "absolute",   
  "top": (windowHeight-popupHeight)/2+jQuery(document).scrollTop(),   
  "left": (windowWidth-popupWidth)/2   
 });  
}
</script>
<?php
}
?>
