<?php
function rpur_import_page(){
	
	if(isset($_POST['rpur_import_update'])){
		
		$feeds=preg_split('(\n|\r)',$_POST['rpur_import_data']);
		
		if($feeds){
			
			if(!function_exists('wp_create_category')) 
				require_once(ABSPATH.'wp-admin/includes/taxonomy.php');
			
			foreach($feeds as $feed){
				if($feed){
					$data = array();
					$feed = explode(',',$feed);
				
					$data['name'] = $feed[0];
					$data['url'] = $feed[1];

					$data['category']= get_cat_ID($feed[2]);
				
					if( $data['category'] == 0)
						$data['category'] = wp_create_category($feed[2]);
				
					if( $data['category'] == 0)
						$data['category'] = 1;
				
					$data['tags'] = str_replace('|',',',$feed[3]);

					$data['frequency'] = absint($feed[4]);

					$data['frequency'] = absint($data['frequency']);
					

					$data['max_items'] = absint($feed[5]);
					$data['rewrite'] = $feed[6];
					if( $$data['rewrite'] !='Yes' && $data['rewrite'] != 'No' )
						$data['rewrite'] = 'Yes';
					$data['post_status'] = $feed[7];
					if( $data['post_status'] !='publish' && $data['post_status'] != 'draft' )
						$data['post_status'] = 'publish';

					$data['post_interval'] = absint($feed[8]);
					$user = get_userdatabylogin($feed[9]);
					
					$data['author'] = $user->ID;
					$data['author'] = ($data['author'] == 0)? 1: $data['author'];

					rpur_insert_feed($data);
				}
		
			}

			echo	'<div id="message" class="updated fade"><p>Done! Go to <a href="admin.php?page=rpur_feed_page">Settings</a> to see the results.</p></div>';
		}

	}
	
	
	
		
?>	
	<div class="wrapper">
	<h2>Import</h2>
	<form method='post'>
	<p>Format:</p>
	<p><b>feed name,feed url,category,tag1|tag2|tag3,update every(minutes),get articles,rewrite,post status,post interval(hours),author</b></p>
	<p>e.g. wprssposter,http://www.wprssposter.com/blog/feed/,News,update|new features,86400,3,Yes,publish,8,admin</p>
	
	<p>category will be created if not exist.</p>
	<p>update every(hours), get articles and post interval must be positive integer!</p>
	<p>update every must be the multiple of 8.</p>
	<p>rewrite must be Yes or No. (case sensitive)</p>
	<p>post status must be publish or draft. (case sensitive)</p>
	<p>Author must be the user's username (login name).</p>
	<p><b>Please note:</b> tags are separated by "|"</p>
	<p><textarea name="rpur_import_data" rows="20" cols="100"></textarea></p>
	<p><input type="hidden" name="rpur_import_update"/></p>
	<p><input class="button-primary" type="submit" name="save" value="Import" /></p>
	</div>

<?
}

?>
