<?php
/*
Plugin Name: RSSPoster PRO Version  - Onlywire.com Module
Plugin URI: http://www.wprssposter.com/blog/
Description: RSSPoster PRO Version  - Onlywire.com Module
Version: 0.1
Author: Jesse
Author URI: http://www.wprssposter.com/blog/
*/

add_action('publish_post', 'rpur_onlywire_post_info');
add_action('admin_menu', 'rpur_onlywire_menu');
//register_deactivation_hook(__FILE__, 'rpur_onlywire_deactive');
register_activation_hook(__FILE__, 'rpur__onlywire_activate');
function rpur_onlywire_deactive(){

	delete_option('rpur_onlywire');
}
function rpur__onlywire_activate(){
	$rpur_onlywire = get_option('rpur_onlywire');
	if( empty($rpur_onlywire) ){
			
			$rpur_onlywire['account'][] = array('username' => 'Put your username here','password' => 'password', 'enable' => true  );
			$rpur_onlywire['account'][] = array('username' => 'Put your username here','password' => 'password', 'enable' => false );
			$rpur_onlywire['account'][] = array('username' => 'Put your username here','password' => 'password', 'enable' => false );
			$rpur_onlywire['spam_protection']=true;
			add_option('rpur_onlywire',$rpur_onlywire);
		
		
	}
}
function rpur_onlywire_menu(){
	
	if(!is_plugin_active('RSSPoster_PRO/index.php')){
		echo '<div id="notice" class="error"><p>';
				printf( '<b>Onlywire.com Module:</b> Please Activate RSS Poster PRO Version to use onlywire.com module. '  );
		echo '</p></div>'. "\n";

	}else{
		
		add_menu_page('Onlywire.com Module', 'Onlywire.com Module', 8,'rpur_onlywire_page',  'rpur_onlywire_page');
		
		
	}

}
function rpur_onlywire_post_info($id){
	
	$rpur_onlywire = get_option('rpur_onlywire');
	
	if( $rpur_onlywire['spam_protection'] && (1 != rand(0,3)) ){
				rpur_log("Decide not to update onlywire.com for spam protection");
				return;
	}
	
	if($_POST['action'] != "autosave" && $_POST['post_status'] != "draft"){

		$mypost = get_post($id);

		$title = strip_tags($mypost->post_title);
		$content = strip_tags($mypost->post_content);
		$postlink = get_permalink($id);

		$posttags = get_the_tags($id);
		if ($posttags) {
			foreach($posttags as $tag) {
				$tags .= $tag->name . ' ';
			}
		}

		$comments = rpur_onlywire_cut_str($content,200);
		$url = 'http://[username]:[password]@onlywire.com/api/add?url='.urlencode($postlink).'&title='.urlencode($title).'&tags='.urlencode($tags).'&comments='.urlencode($comments);
		
		rpur_log("Begin to update onlywire.");

		foreach($rpur_onlywire['account'] as $acct){

			if($acct['enable']){
				$realurl=str_replace( array('[username]','[password]'), array($acct['username'], $acct['password']), $url);
				rpur_onlywire_update($realurl,$title);
			}
		}

	}

}
function rpur_onlywire_update($url,$title){
	
	$rtn = rpur_get_file($url);
	if($rtn == 'success'){
		rpur_log('<b>'.$title.'</b> might have been updated to onlywire.com');
	}elseif($rtn =='failure'){
		
		rpur_log('Onlywire.com Update failed!');

	}elseif($rtn ==''){
		rpur_log("Check your username and password of onlywire.com.");
	}
	
	

}
function rpur_onlywire_cut_str($str, $len) {
    if (!isset($str[$len])) {
    } else {
        if (seems_utf8($str[$len-1])) 
            $str = substr($str, 0, $len); 
        else { 
            if(seems_utf8($str[$len-3].$str[$len-2].$str[$len-1]))
                $str = substr($str, 0, $len-3) . $str[$len-3] . $str[$len-2] . $str[$len-1];

            elseif(seems_utf8($str[$len-2].$str[$len-1].$str[$len]))
                $str = substr($str, 0, $len-2) . $str[$len-2].$str[$len-1].$str[$len];

            elseif(seems_utf8($str[$len-1].$str[$len].$str[$len+1]))
                $str = substr($str, 0, $len-1) . $str[$len-1].$str[$len].$str[$len+1];

            else 
                $str = substr($str, 0, $len);
        }
    }
    return $str;
}
function rpur_onlywire_page(){

		$rpur_onlywire = get_option('rpur_onlywire');
		if($_POST['rpur_onlywire_update'] == 'rpur_onlywire_update'){

			$rpur_onlywire['spam_protection'] = ($_POST['spam_protection'])?true:false;

			unset($_POST['spam_protection']);

			unset($_POST['rpur_onlywire_update']);

			unset($_POST['save']);
			
			foreach($_POST as $k => $v){

				$acct=explode('-',$k);
			
				$rpur_onlywire['account'][$acct[0]][$acct[1]] = $v;
			
			}
			update_option('rpur_onlywire',$rpur_onlywire);
			echo	'<div id="message" class="updated fade"><p>Saved!</p></div>';
		}
		
?>
	 <div class="wrapper">
	<h2>RSS Poster PRO Version - Onlywire.com Module Settings</h2>
	
	<form method="post" action="">
	<table style="margin-top: 1em;" class="widefat">
	<thead><tr><th scope="col">Onlywire.com Account Settings</th></tr></thead>

	<tbody>
	<tr>
	<td scope="col">
		<p><i>Account No.1</i>
		<input type="text" size="30" name="0-username" value="<?php echo $rpur_onlywire['account'][0]['username']; ?>" />
		<input type="password" size="30" name="0-password" value="<?php echo $rpur_onlywire['account'][0]['password']; ?>" />
		Enable <input type="checkbox" name="0-enable" 
		<?php	
		if($rpur_onlywire['account'][0]['enable'])
			echo ' checked="yes" ';
		else 
			echo ' /></p>';
		?>

		
	</td>
	</tr>

	<tr>
	<td scope="col">
		<p><i>Account No.2</i>
		<input type="text" size="30" name="1-username" value="<?php echo $rpur_onlywire['account'][1]['username']; ?>" />
		<input type="password" size="30" name="1-password" value="<?php echo $rpur_onlywire['account'][1]['password']; ?>" />
		Enable <input type="checkbox" name="1-enable" 
		<?php	
		if($rpur_onlywire['account'][1]['enable'])
			echo ' checked="yes" ';
		else 
			echo ' /></p>';
		?>

		
	</td>
	</tr>


	<tr>
	<td scope="col">
		<p><i>Account No.3</i>
		<input type="text" size="30" name="2-username" value="<?php echo $rpur_onlywire['account'][2]['username']; ?>" />
		<input type="password" size="30" name="2-password" value="<?php echo $rpur_onlywire['account'][2]['password']; ?>" />
		Enable <input type="checkbox" name="2-enable" 
		<?php	
		if($rpur_onlywire['account'][2]['enable'])
			echo ' checked="yes" ';
		else 
			echo ' /></p>';
		?>

		
	</td>
	</tr>

	</tbody>
	</table>

	<table style="margin-top: 1em;" class="widefat">
	 <h3>Spam Protection</h3>
	 <p>If this option enabled, Onlywire.com Module will randomly choose to update your onlywire.com when a post published.</p> 
	<thead><tr><th scope="col"></th></tr></thead>
      

	<tbody>
	<tr>
	<td scope="col">
	  <p>Spam Protection: <input type="checkbox" name="spam_protection" 
	<?php	
		if($rpur_onlywire['spam_protection'])
			echo ' checked="yes" ';
		else 
			echo ' /></p>';
		?>
	</td>
	</tr>
	</tbody>
	</table>

	<p><input type="hidden" name="rpur_onlywire_update" value="rpur_onlywire_update" /></p>
	<p><input class="button-primary" type="submit" name="save" value="Save" /></p>
		
	</form>
	</div>


<?php	
}
?>
