<?php
function rpur_misc_page(){
	$rpur_options = get_option('rpur_options');
		
	if( $_POST['rpur_misc_update']=='rpur_misc_update' ){
		
		if(!empty($_POST['cache_image']))
			$rpur_options['cache_image']=true;
		else
			$rpur_options['cache_image']=false;

		if(!empty($_POST['enable_cron_job']))
			$rpur_options['enable_cron_job'] = true;
		else
			$rpur_options['enable_cron_job'] = false;

		if(!empty($_POST['display_article_source']))

			$rpur_options['display_article_source'] = true;
		else
			$rpur_options['display_article_source'] = false;

		

		if(!empty($_POST['frequency'])){
			$rpur_options['frequency'] = absint($_POST['frequency']);
			if($rpur_options['frequency'] == 0)
				$rpur_options['frequency'] = 1;
		}
		if(!empty($_POST['custom_template']))
			$rpur_options['custom_template'] = str_replace('\\','',$_POST['custom_template']);

		if(isset($_POST['exclude']))
			$rpur_options['exclude'] = str_replace('\\','',$_POST['exclude']);

		if(isset($_POST['include']))
			$rpur_options['include'] = str_replace('\\','',$_POST['include']);

		if(isset($_POST['remove_pairs']))
			$rpur_options['remove_pairs'] = str_replace('\\','',$_POST['remove_pairs']);

		$rpur_options['word_limit'] = absint($_POST['word_limit']);

		update_option('rpur_options',$rpur_options);

		echo	'<div id="message" class="updated fade"><p>Saved!</p></div>';

	}
?>
<div class="wrapper">
		<h2>Misc Settings</h2>
		<form method="post" action="">

	<table style="margin-top: 1em;" class="widefat">
	<thead><tr><th scope="col">Basic Options</th></tr></thead>

	<tbody>
	<tr>
	<td scope="col">
	
	
		
		
		<p><b>Cache Image</b><input type="checkbox" name="cache_image"
	        <?php	if ($rpur_options['cache_image'])
			echo' checked="yes" ';
		
			echo ' /></p>';
		?>
		<p>The cache directory must be writeable.</p>

	
	</td>
	</tr>

	</tbody>
	</table>


		<table style="margin-top: 1em;" class="widefat">
	<thead><tr><th scope="col">Content Options</th></tr></thead>

	<tbody>
	<tr>
	<td scope="col">
		
		<b>Word limit(0 means full content):</b><br />
		<p><textarea name="word_limit" rows="1" cols="2"><?php echo $rpur_options['word_limit'];?></textarea></p>
		<br />

		<p>Please see <a href="http://www.wprssposter.com/blog/?p=42">0.8.7 changelog</a> for notes about these two options!</p>
		<b>Exclude post titles matching (comma separated words):</b><br />
	
		<p><textarea name="exclude" rows="1" cols="50"><?php echo $rpur_options['exclude'];?></textarea></p>

		<b>Include post titles matching (comma separated words):</b><br />
	
		<p><textarea name="include" rows="1" cols="50"><?php echo $rpur_options['include'];?></textarea></p>
		<br />
		<b>Remove "Related Posts" or something</b><br />
		One pair per line<br />
		<p>Please see <a href="http://www.wprssposter.com/blog/?p=42">0.8.5 changelog</a> to know how it works!</p>
		<p><textarea name="remove_pairs" rows="10" cols="40"><?php echo $rpur_options['remove_pairs'];?></textarea></p>
		<em>(.*) means the content between html tags.</em>
	
	</td>
	</tr>

	</tbody>
	</table>

	<table style="margin-top: 1em;" class="widefat">
	<thead><tr><th scope="col">Custom Article Source Template</th></tr></thead>

	<tbody>
	<tr>
	<td scope="col">
	
		<p><b>Display article source at the bottom of every post.</b>
		<input type="checkbox" class="display_article_source" name="display_article_source" 
		<?php	
		if($rpur_options['display_article_source'])
			echo ' checked="yes" ';
		
			echo ' /></p>';
		?>

		<p><textarea name="custom_template" rows="2" cols="100"><?php echo $rpur_options['custom_template'];?></textarea></p>
		<p>Variables you can include in the Custom Article Source Template.</p>
		<p><b>%FEED_URL%</b> the feed url</p>
		<p><b>%FEED_NAME%</b> the feed name</p>
		<p><b>%SOURCE_URL%</b> the source URL of the post</p>
		<p><b>%AUTHOR%</b> the author you assign to the feed</p>
		<p><b>%CATEGORY%</b> the category you assign to the feed</p>
		<p><b>If no %SOURCE_URL% found, RSS Poster will automatically append it to the end.</b></p>
		
			
	</td>
	</tr>
	</tbody>
	</table>	


	<table style="margin-top: 1em;" class="widefat">
	<thead><tr><th scope="col">Time Update Options</th></tr></thead>

	<tbody>
	<tr>
	<td scope="col">
		<p><b>Frequency</b>: <input type="text" name="frequency" size="2" value="<?php echo $rpur_options['frequency'];?>" />Hours</p>
		<p>Set the frequency that RSS Poster will automatically fire off to process and update all feeds! This option is designed for people who don't want to enable cron job.</p>
		<p><b>Please note:</b>This option won't work if cron job enabled!</p>
		<p><b>Enable Cron Job</b><input type="checkbox" class="enable_cron_job" name="enable_cron_job" 
		<?php	
		if($rpur_options['enable_cron_job'])
			echo ' checked="yes" ';
		else 
			echo ' /></p>';
		?>
		<p>Don't toggle it unless you know what cron job is and how to use. Otherwise, RSS Poster won't work correctly!</p>
		<div id="cron_job_mode">
		<p>With cron job, you can let RSS Poster to process and update all feeds at any time as long as you know how to use cron job command.</p>
		<p>Here is your cron url. <b><?php echo $rpur_options['cron_url'];?></b></p>
		<p>Recommended Online Cron Job Service : <b>www.setcronjob.com<b></p>
		<p></p>
		</div>
		
</td>
	</tr>
	</tbody>
	</table>
		


		<p><input type="hidden" name="rpur_misc_update" value="rpur_misc_update" /></p>
		<p><input class="button-primary" type="submit" name="save" value="Save" /></p>
		
		</form>
		</div>
<?php
}
?>
